// Code generated by protoc-gen-go. DO NOT EDIT.
// source: numbers.proto

package numbers

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type StatelessParameters struct {
	// The latest received number, used to resume sending the number sequence if the connection is lost
	LatestReceivedNumber int32    `protobuf:"varint,1,opt,name=latestReceivedNumber,proto3" json:"latestReceivedNumber,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *StatelessParameters) Reset()         { *m = StatelessParameters{} }
func (m *StatelessParameters) String() string { return proto.CompactTextString(m) }
func (*StatelessParameters) ProtoMessage()    {}
func (*StatelessParameters) Descriptor() ([]byte, []int) {
	return fileDescriptor_numbers_a80ae33193be7df1, []int{0}
}
func (m *StatelessParameters) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_StatelessParameters.Unmarshal(m, b)
}
func (m *StatelessParameters) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_StatelessParameters.Marshal(b, m, deterministic)
}
func (dst *StatelessParameters) XXX_Merge(src proto.Message) {
	xxx_messageInfo_StatelessParameters.Merge(dst, src)
}
func (m *StatelessParameters) XXX_Size() int {
	return xxx_messageInfo_StatelessParameters.Size(m)
}
func (m *StatelessParameters) XXX_DiscardUnknown() {
	xxx_messageInfo_StatelessParameters.DiscardUnknown(m)
}

var xxx_messageInfo_StatelessParameters proto.InternalMessageInfo

func (m *StatelessParameters) GetLatestReceivedNumber() int32 {
	if m != nil {
		return m.LatestReceivedNumber
	}
	return 0
}

type StatelessNumber struct {
	Number               int32    `protobuf:"varint,1,opt,name=number,proto3" json:"number,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *StatelessNumber) Reset()         { *m = StatelessNumber{} }
func (m *StatelessNumber) String() string { return proto.CompactTextString(m) }
func (*StatelessNumber) ProtoMessage()    {}
func (*StatelessNumber) Descriptor() ([]byte, []int) {
	return fileDescriptor_numbers_a80ae33193be7df1, []int{1}
}
func (m *StatelessNumber) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_StatelessNumber.Unmarshal(m, b)
}
func (m *StatelessNumber) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_StatelessNumber.Marshal(b, m, deterministic)
}
func (dst *StatelessNumber) XXX_Merge(src proto.Message) {
	xxx_messageInfo_StatelessNumber.Merge(dst, src)
}
func (m *StatelessNumber) XXX_Size() int {
	return xxx_messageInfo_StatelessNumber.Size(m)
}
func (m *StatelessNumber) XXX_DiscardUnknown() {
	xxx_messageInfo_StatelessNumber.DiscardUnknown(m)
}

var xxx_messageInfo_StatelessNumber proto.InternalMessageInfo

func (m *StatelessNumber) GetNumber() int32 {
	if m != nil {
		return m.Number
	}
	return 0
}

// Parameters to the stateful client, both parameters have to be sent again if the connection is lost
type StatefulParameters struct {
	// Unique identifier for the client
	Uuid string `protobuf:"bytes,1,opt,name=uuid,proto3" json:"uuid,omitempty"`
	// A random number
	RandomNumber         int32    `protobuf:"varint,2,opt,name=randomNumber,proto3" json:"randomNumber,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *StatefulParameters) Reset()         { *m = StatefulParameters{} }
func (m *StatefulParameters) String() string { return proto.CompactTextString(m) }
func (*StatefulParameters) ProtoMessage()    {}
func (*StatefulParameters) Descriptor() ([]byte, []int) {
	return fileDescriptor_numbers_a80ae33193be7df1, []int{2}
}
func (m *StatefulParameters) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_StatefulParameters.Unmarshal(m, b)
}
func (m *StatefulParameters) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_StatefulParameters.Marshal(b, m, deterministic)
}
func (dst *StatefulParameters) XXX_Merge(src proto.Message) {
	xxx_messageInfo_StatefulParameters.Merge(dst, src)
}
func (m *StatefulParameters) XXX_Size() int {
	return xxx_messageInfo_StatefulParameters.Size(m)
}
func (m *StatefulParameters) XXX_DiscardUnknown() {
	xxx_messageInfo_StatefulParameters.DiscardUnknown(m)
}

var xxx_messageInfo_StatefulParameters proto.InternalMessageInfo

func (m *StatefulParameters) GetUuid() string {
	if m != nil {
		return m.Uuid
	}
	return ""
}

func (m *StatefulParameters) GetRandomNumber() int32 {
	if m != nil {
		return m.RandomNumber
	}
	return 0
}

type StatefulNumber struct {
	Number uint32 `protobuf:"varint,1,opt,name=number,proto3" json:"number,omitempty"`
	// The checksum is only sent within the latest message
	Checksum             uint32   `protobuf:"varint,2,opt,name=checksum,proto3" json:"checksum,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *StatefulNumber) Reset()         { *m = StatefulNumber{} }
func (m *StatefulNumber) String() string { return proto.CompactTextString(m) }
func (*StatefulNumber) ProtoMessage()    {}
func (*StatefulNumber) Descriptor() ([]byte, []int) {
	return fileDescriptor_numbers_a80ae33193be7df1, []int{3}
}
func (m *StatefulNumber) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_StatefulNumber.Unmarshal(m, b)
}
func (m *StatefulNumber) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_StatefulNumber.Marshal(b, m, deterministic)
}
func (dst *StatefulNumber) XXX_Merge(src proto.Message) {
	xxx_messageInfo_StatefulNumber.Merge(dst, src)
}
func (m *StatefulNumber) XXX_Size() int {
	return xxx_messageInfo_StatefulNumber.Size(m)
}
func (m *StatefulNumber) XXX_DiscardUnknown() {
	xxx_messageInfo_StatefulNumber.DiscardUnknown(m)
}

var xxx_messageInfo_StatefulNumber proto.InternalMessageInfo

func (m *StatefulNumber) GetNumber() uint32 {
	if m != nil {
		return m.Number
	}
	return 0
}

func (m *StatefulNumber) GetChecksum() uint32 {
	if m != nil {
		return m.Checksum
	}
	return 0
}

func init() {
	proto.RegisterType((*StatelessParameters)(nil), "numbers.StatelessParameters")
	proto.RegisterType((*StatelessNumber)(nil), "numbers.StatelessNumber")
	proto.RegisterType((*StatefulParameters)(nil), "numbers.StatefulParameters")
	proto.RegisterType((*StatefulNumber)(nil), "numbers.StatefulNumber")
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// NumbersClient is the client API for Numbers service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type NumbersClient interface {
	StatelessGetNumbers(ctx context.Context, in *StatelessParameters, opts ...grpc.CallOption) (Numbers_StatelessGetNumbersClient, error)
	StatefulGetNumbers(ctx context.Context, in *StatefulParameters, opts ...grpc.CallOption) (Numbers_StatefulGetNumbersClient, error)
}

type numbersClient struct {
	cc *grpc.ClientConn
}

func NewNumbersClient(cc *grpc.ClientConn) NumbersClient {
	return &numbersClient{cc}
}

func (c *numbersClient) StatelessGetNumbers(ctx context.Context, in *StatelessParameters, opts ...grpc.CallOption) (Numbers_StatelessGetNumbersClient, error) {
	stream, err := c.cc.NewStream(ctx, &_Numbers_serviceDesc.Streams[0], "/numbers.Numbers/StatelessGetNumbers", opts...)
	if err != nil {
		return nil, err
	}
	x := &numbersStatelessGetNumbersClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Numbers_StatelessGetNumbersClient interface {
	Recv() (*StatelessNumber, error)
	grpc.ClientStream
}

type numbersStatelessGetNumbersClient struct {
	grpc.ClientStream
}

func (x *numbersStatelessGetNumbersClient) Recv() (*StatelessNumber, error) {
	m := new(StatelessNumber)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *numbersClient) StatefulGetNumbers(ctx context.Context, in *StatefulParameters, opts ...grpc.CallOption) (Numbers_StatefulGetNumbersClient, error) {
	stream, err := c.cc.NewStream(ctx, &_Numbers_serviceDesc.Streams[1], "/numbers.Numbers/StatefulGetNumbers", opts...)
	if err != nil {
		return nil, err
	}
	x := &numbersStatefulGetNumbersClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Numbers_StatefulGetNumbersClient interface {
	Recv() (*StatefulNumber, error)
	grpc.ClientStream
}

type numbersStatefulGetNumbersClient struct {
	grpc.ClientStream
}

func (x *numbersStatefulGetNumbersClient) Recv() (*StatefulNumber, error) {
	m := new(StatefulNumber)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// NumbersServer is the server API for Numbers service.
type NumbersServer interface {
	StatelessGetNumbers(*StatelessParameters, Numbers_StatelessGetNumbersServer) error
	StatefulGetNumbers(*StatefulParameters, Numbers_StatefulGetNumbersServer) error
}

func RegisterNumbersServer(s *grpc.Server, srv NumbersServer) {
	s.RegisterService(&_Numbers_serviceDesc, srv)
}

func _Numbers_StatelessGetNumbers_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(StatelessParameters)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(NumbersServer).StatelessGetNumbers(m, &numbersStatelessGetNumbersServer{stream})
}

type Numbers_StatelessGetNumbersServer interface {
	Send(*StatelessNumber) error
	grpc.ServerStream
}

type numbersStatelessGetNumbersServer struct {
	grpc.ServerStream
}

func (x *numbersStatelessGetNumbersServer) Send(m *StatelessNumber) error {
	return x.ServerStream.SendMsg(m)
}

func _Numbers_StatefulGetNumbers_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(StatefulParameters)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(NumbersServer).StatefulGetNumbers(m, &numbersStatefulGetNumbersServer{stream})
}

type Numbers_StatefulGetNumbersServer interface {
	Send(*StatefulNumber) error
	grpc.ServerStream
}

type numbersStatefulGetNumbersServer struct {
	grpc.ServerStream
}

func (x *numbersStatefulGetNumbersServer) Send(m *StatefulNumber) error {
	return x.ServerStream.SendMsg(m)
}

var _Numbers_serviceDesc = grpc.ServiceDesc{
	ServiceName: "numbers.Numbers",
	HandlerType: (*NumbersServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "StatelessGetNumbers",
			Handler:       _Numbers_StatelessGetNumbers_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "StatefulGetNumbers",
			Handler:       _Numbers_StatefulGetNumbers_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "numbers.proto",
}

func init() { proto.RegisterFile("numbers.proto", fileDescriptor_numbers_a80ae33193be7df1) }

var fileDescriptor_numbers_a80ae33193be7df1 = []byte{
	// 239 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x09, 0x6e, 0x88, 0x02, 0xff, 0xe2, 0xe2, 0xcd, 0x2b, 0xcd, 0x4d,
	0x4a, 0x2d, 0x2a, 0xd6, 0x2b, 0x28, 0xca, 0x2f, 0xc9, 0x17, 0x62, 0x87, 0x72, 0x95, 0x3c, 0xb9,
	0x84, 0x83, 0x4b, 0x12, 0x4b, 0x52, 0x73, 0x52, 0x8b, 0x8b, 0x03, 0x12, 0x8b, 0x12, 0x73, 0x53,
	0x4b, 0x80, 0xc2, 0x42, 0x46, 0x5c, 0x22, 0x39, 0x40, 0xd1, 0xe2, 0x92, 0xa0, 0xd4, 0xe4, 0xd4,
	0xcc, 0xb2, 0xd4, 0x14, 0x3f, 0xb0, 0x7a, 0x09, 0x46, 0x05, 0x46, 0x0d, 0xd6, 0x20, 0xac, 0x72,
	0x4a, 0x9a, 0x5c, 0xfc, 0x70, 0xa3, 0x20, 0x42, 0x42, 0x62, 0x5c, 0x6c, 0x79, 0xc8, 0x1a, 0xa1,
	0x3c, 0x25, 0x1f, 0x2e, 0x21, 0xb0, 0xd2, 0xb4, 0xd2, 0x1c, 0x24, 0x4b, 0x85, 0xb8, 0x58, 0x4a,
	0x4b, 0x33, 0x53, 0xc0, 0x6a, 0x39, 0x83, 0xc0, 0x6c, 0x21, 0x25, 0x2e, 0x9e, 0xa2, 0xc4, 0xbc,
	0x94, 0xfc, 0x5c, 0xa8, 0x03, 0x98, 0xc0, 0xe6, 0xa0, 0x88, 0x29, 0xb9, 0x70, 0xf1, 0xc1, 0x4c,
	0xc3, 0x6a, 0x2f, 0x2f, 0xcc, 0x5e, 0x21, 0x29, 0x2e, 0x8e, 0xe4, 0x8c, 0xd4, 0xe4, 0xec, 0xe2,
	0xd2, 0x5c, 0xb0, 0x49, 0xbc, 0x41, 0x70, 0xbe, 0xd1, 0x1a, 0x46, 0x2e, 0x76, 0x88, 0xf6, 0x62,
	0xa1, 0x40, 0xa4, 0x50, 0x71, 0x4f, 0x2d, 0x81, 0x09, 0xcb, 0xe8, 0xc1, 0x42, 0x11, 0x4b, 0x98,
	0x49, 0x49, 0x60, 0xca, 0x42, 0x1d, 0xc8, 0x60, 0xc0, 0x28, 0xe4, 0x87, 0xf0, 0x32, 0x92, 0x89,
	0xd2, 0xa8, 0x7a, 0x50, 0xc2, 0x43, 0x4a, 0x1c, 0x43, 0x12, 0x61, 0x5e, 0x12, 0x1b, 0x38, 0x22,
	0x8d, 0x01, 0x01, 0x00, 0x00, 0xff, 0xff, 0xf0, 0x59, 0x84, 0xd7, 0xd9, 0x01, 0x00, 0x00,
}
